#include <p18cxxx.h>
#include "hardware.h"
//#include "lcd\lcd.h"
#include "adc.h"


/**
 *	Analogeingang RA5
ADRESH=0x00	ADRESL=
				+10/20		+9/20	
0	0x00	0		0,5		0,45
1	0x14	20		1,5		1,45
2	0x2a	42		2,6		2,55
3	0x3e	62		3,6		3,55
4	0x4b	75		4,25	4,2
5	0x60	96		5,3		5,25
6	0x75	117		6,35	6,3
7	0x8b	139		7,45	7,4
 */

#pragma code
void initADC(void) {

//	ADCON1 &= 0xfa;	//AN4 analog

    TRISAbits.RA5 = 1; // AN4 Analog Mode selection
    #if defined AN7_io  
        TRISEbits.RE2 = 1; // AN7 Analog Mode selection
    #endif //AN7_io

	//++CONFIG3H PBADEN =1 ==> ADCON1.PCFG =0
	//	CONFIG3H PBADEN =0 ==> ADCON1.PCFG =7

//	ADCON1 = 0x07;	// Vref = AVSS/AVDD; Analog Input AN0..7
//  ADCON1 = 0x00;	// Vref = AVSS/AVDD; Analog Input AN0..7
	ADCON1 = 0x0a; // Vref = AVSS/AVDD; Analog Input AN0..4
    ADCON2 = 0xbe; // right justified (ADRESH); Aquisition Time = 20TAD; AD-Clock FOSC/64
}

uint8_t readMode_AN4(void) {

	uint8_t mode0;
//	ADCON1 = 0x0a; // Vref = AVSS/AVDD; Analog Input AN0..4
    if (ADCON0bits.DONE == 0) {     //fertig mit convertieren wegen neue conf
        initADC();

        

        while (ADCON0bits.DONE == 1);
        mode0= ((ADRES+5) /20);
    }
        return mode0;
}

#if defined AN7_io
unsigned int readTastatur_AN7(void){

	unsigned int taste;

	initADC();

    ADCON0bits.CHS = 7; // Channel selected AN7;
    ADCON0bits.ADON = 1; // AD/Conversion Enabled; Start Conversion
    ADCON0bits.GO = 1;
	while (ADCON0bits.DONE == 1);

	taste = ADRES;

	return taste;
}
#endif  //AN7_io






